///////////////////////////////////////////////////////////////////////////////
//
//  Function-oriented code created by the Xbase++ FormDesigner
//    Creation date: 12/23/2009 Time: 12:58:03
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "xbp.ch"
#include "fileio.ch"
#INCLUDE "xbp.ch"

#PRAGMA LIBRARY( "ASCOM10.LIB" )

PROCEDURE Main
   LOCAL nEvent, mp1, mp2, aSize
   LOCAL oDlg, oXbp, drawingArea, aEditControls := {}

   IF IsMemberVar(XbpDialog(),"ClientSize") == .T.
      aSize := {0,0}
   ELSE
      aSize := {600,408}
   ENDIF
//msgbox(version(3) )
   oDlg := XbpDialog():new( AppDesktop(), , {600,329}, aSize, , .F.)
   IF aSize[1] == 0 .AND. aSize[2] == 0
      oDlg:ClientSize := {592,374}
   ENDIF
   oDlg:taskList := .T.
   oDlg:title := "New form"
   oDlg:create()

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( "8.Arial" )

   oXbp := XbpSLE():new( drawingArea, , {96,276}, {84,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   oXbp:tabStop := .T.
   oXbp:create()

   oXbp := XbpActiveXControl():new( drawingArea, , {180,168}, {84,84} )
   oXbp:CLSID := "{9A36ABD5-8EAF-4EC9-AA4E-04E631B399C1}"
   oXbp:TabStop := .T.
   oXbp:create()

   oXbp := XbpPushButton():new( drawingArea, , {60,336}, {120,36}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   oXbp:caption := "Update Payments"
   oXbp:tabStop := .T.
   oXbp:create()
   oXbp:activate := {|| CIPUpdatePayments() }

   oXbp := XbpPushButton():new( drawingArea, , {216,324}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   oXbp:caption := "Credit Sale"
   oXbp:tabStop := .T.
   oXbp:create()
   oXbp:activate := {|| CIPCreditSale() }

   oDlg:show()
   SetAppFocus(oDlg)

   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN
////////////////////////////////////////////////////


******************************************
function CIPUpdatePayments()
Local oEasyIntegrator, ret_val:=.f.
local SetupString:='',nVar:=1
local trans
local oCustfields
local oCustomer
local StringSavedCustomerRef:=''

SetupString:=GetCIPsetup(nVar)
if !(ValType(oEasyIntegrator)) == 'O'
   oEasyIntegrator:=ActiveXObject():Create("cipwin32.EasyIntegrator")
endif

IF NIL == oEasyIntegrator                                                   // test to see if it got created
    msgbox( "Error: " + Chr(13) + Chr(10) + "Description: " + ComLastMessage() )
    //MsgBox( "Description:" + ComLastMessage() )                             // show error message if not
    RETURN .f.
ElSE
    ret_val := .t.
ENDIF

   oEasyIntegrator:LoadSetup(SetupString)
   trans := oEasyIntegrator:getProperty('TransFields')
   trans:AmountTotal := 4
   oCustomer := oEasyIntegrator:getProperty('Customer')
   oCustfields := oCustomer:getProperty('CustomerFields')
   oEasyIntegrator:Customer:CustomerFields:Clear()
   oCustfields:FirstName := 'Enrico'
   oCustfields:LastName := 'Fermi'
   oCustfields:Company := 'E=mc2'
   oCustomer:UpdatePayments('50243')     //43234     //50243
   StringSavedCustomerRef = oEasyIntegrator:Customer:CustomerRef
   msgbox(StringSavedCustomerRef)
return ret_val

******************************************
function CIPCreditSale()
Local oEasyIntegrator, ret_val:=.f.
local SetupString:='',nVar:=1
local trans
local oCustfields
local oCustomer

SetupString:=GetCIPsetup(nVar)
if !(ValType(oEasyIntegrator)) == 'O'
   oEasyIntegrator:=ActiveXObject():Create("cipwin32.EasyIntegrator")
endif

IF NIL == oEasyIntegrator                                                   // test to see if it got created
    msgbox( "Error: " + Chr(13) + Chr(10) + "Description: " + ComLastMessage() )
    RETURN .f.
ElSE
    ret_val := .t.
ENDIF

   oEasyIntegrator:LoadSetup(SetupString)
   trans := oEasyIntegrator:getProperty('TransFields')
   trans:AmountTotal := 4
   oCustomer := oEasyIntegrator:getProperty('Customer')
   oCustomer:CustomerRef := '50243'
   oEasyIntegrator:CreditSale()

return ret_val


*/
*********************************************
procedure CIPwrite(CIPString)
local nHandle,mpath

    mpath  := 'CIPsetup.xml'
    nHandle:= FCreate(mpath,FC_NORMAL)
    IF nHandle == -1
         msgbox('Error creating CIP setup file: ' + str(FError()) )
    ELSE
         FWrite( nHandle, CIPString)
         FClose( nHandle )
         msgbox('Setup string saved to CIPsetup.xml file')
    ENDIF

return
**********************************************
function GetCIPsetup(nVar)
    #include "fileio.ch"
    local n:=0
    local nHandle, m_File, CIPsetup:=space(4000), nBytes:=0

    // nVar = 1  calling setup screen
    // nVar = 2  loading setup

    if nVar = 2
         msgbox('Loading setup from CIPsetup.xml file')
    endif

    m_File:='CIPsetup.xml'
    if file(m_File)
        nHandle:=FOPEN(m_File,FO_READ)
        if ferror() !=0
            msgbox('File Open Error ')
        else
       nBytes:=fread(nHandle,@CIPsetup,4000)
            fclose(nHandle)
        endif
        CIPsetup:=trim(CIPsetup)
        if nVar = 2
            msgbox('setup loaded')
        endif

    endif

return CIPsetup
******************************************

**********************************************8
procedure ExitProgram()
   QUIT
return


